#include "main.h"
#include <string.h>

static Scene *scn;


int main(int argc, char **argv)
{
  Scene *s;
  int k; Object *o;

  init_lang();
  scn = scene_read();

  init_glut("GPU", scn);
  setup_scene_gl(scn);
  load_objects_gl(scn->objs);
  glutMainLoop();
  close_gl(scn);
  exit(0);
}


// ------------------------------

void display(void)
{
  display_gl(scn);
  glutSwapBuffers();
  glutPostRedisplay();
}

void process_key(unsigned char key, int x, int y) 
{
  if (key == 27 || key == 'q') 
    exit(0);
}

void idle(void)
{
  glutPostRedisplay();
}

void init_glut(char *name, Scene *s)
{
  int ac = 0; char *av[1] = {""};
  glutInit(&ac, av);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  glutInitWindowSize(s->img->w, s->img->h);
  glutCreateWindow(name);

  glutDisplayFunc( display );
  glutKeyboardFunc( process_key );
  glutIdleFunc( idle );
  
}


// ------------------------------

void init_lang(void)
{
  lang_defun("scene", scene_parse);
  lang_defun("view", view_parse);
  lang_defun("dist_light", distlight_parse);
  lang_defun("plastic", plastic_parse);

  lang_defun("shaderprog", shaderprog_parse);

  lang_defun("meshobj", obj_parse);
  lang_defun("mesh", imesh_parse);

  lang_defun("primobj", obj_parse);
  lang_defun("sphere", sphere_parse);

  lang_defun("group", graph_parse);
  lang_defun("affine", xaffine_parse);

  lang_defun("slideproj", slideproj_parse);
  lang_defun("shiny", shiny_parse);
  lang_defun("rough", rough_parse);
  lang_defun("textured", textured_parse);
  lang_defun("imagemap", imagemap_parse);
  lang_defun("chequer", chequer_parse);

  lang_defun("arg", arg_parse);
  lang_defun("motor", motor_parse);

  lang_defun("include", include_parse);
}

