#include "geom.h"
#include "poly.h"

static Hpoly *hplist = NULL;

static void tri_refine(Vector3 v0, Vector3 v1, Vector3 v2, Real s, int maxrec)
{
  Real l1 = v3_norm(v3_sub(v0, v1));
  Real l2 = v3_norm(v3_sub(v1, v2));
  Real l3 = v3_norm(v3_sub(v2, v0));

  if ((MAX(l1, MAX(l2, l3))) <= s || --maxrec < 0) {
    hplist = hpoly_insert(hplist, hpoly3_make(v4_v3conv(v0), v4_v3conv(v1), v4_v3conv(v2)));
  } else {
    Vector3 m1 = v3_scale(0.5, v3_add(v0, v1));
    Vector3 m2 = v3_scale(0.5, v3_add(v1, v2));
    Vector3 m3 = v3_scale(0.5, v3_add(v2, v0));

    tri_refine(m1, v1, m2, s, maxrec);
    tri_refine(m2, v2, m3, s, maxrec);
    tri_refine(m3, v0, m1, s, maxrec);
    tri_refine(m1, m2, m3, s, maxrec);
  }
}

Hpoly *hplist_refine(Hpoly *p, Real s, int maxrec)
{
  hplist = NULL;
  while (p != NULL) {
    tri_refine(v3_v4conv(p->v[0]), v3_v4conv(p->v[1]), v3_v4conv(p->v[2]), s, maxrec);
    p = p->next;
  }
  return hplist;
}

