
#include <QtWidgets>
#include "imageviewer.h"


ImageViewer::ImageViewer(QString fname, float scalefac)
{
    imageLabel = new QLabel;
 
    setCentralWidget(imageLabel);
    setWindowTitle(fname);

    fileName = fname;
    scaleFactor = scalefac;
    open();
}

void ImageViewer::open()
{
    if (!fileName.isEmpty()) {
      QImage input_image(fileName);
      QImage image = input_image.scaledToWidth(input_image.width() * scaleFactor);
      if (image.isNull()) {
	QMessageBox::information(this, tr("Image Viewer"), tr("Cannot load %1.").arg(fileName));
	exit(0);
      }
      imageLabel->setPixmap(QPixmap::fromImage(image));
      resize(image.size());
    }
}

void ImageViewer::keyPressEvent(QKeyEvent *evt)
{
    if(evt->key() == Qt::Key_Q)
        QCoreApplication::quit();
}


